<?php
if ( ! defined('ABSPATH') ) die();
// Admin bootstaps
require_once(ABSPATH.'wp-admin'.DIRECTORY_SEPARATOR.'admin.php');
require_once(ABSPATH.'wp-includes'.DIRECTORY_SEPARATOR.'pluggable.php');

// Do this here just to be on the safe side
if(!is_user_logged_in())
{
	header("Location:".get_bloginfo('home').'/wp-login.php');
	exit();
}
require_once(ARCHITECT_ADMIN_DIR.'wp-admin'.DIRECTORY_SEPARATOR.'functions.php');

$post = get_post_to_edit($_REQUEST['post']);

// Load categories
$descendants_and_self = 0;
$selected_cats = false;
$popular_cats = false;
$post_id = $post->ID;
$post_ID = $post->ID;

$descendants_and_self = (int) $descendants_and_self;
$args = array();

if ( is_array( $selected_cats ) )
	$args['selected_cats'] = $selected_cats;
elseif ( $post_id )
	$args['selected_cats'] = wp_get_post_categories($post_ID);
else
	$args['selected_cats'] = array();

if ( is_array( $popular_cats ) )
	$args['popular_cats'] = $popular_cats;
else
	$args['popular_cats'] = get_terms( 'category', array( 'fields' => 'ids', 'orderby' => 'count', 'order' => 'DESC', 'number' => 10, 'hierarchical' => false ) );

if ( $descendants_and_self ) {
	$categories = get_categories( "child_of=$descendants_and_self&hierarchical=0&hide_empty=0" );
	$self = get_category( $descendants_and_self );
	array_unshift( $categories, $self );
} else {
	$categories = get_categories('get=all');
}

// Post process $categories rather than adding an exclude to the get_terms() query to keep the query the same across all posts (for any query cache)
$checked_categories = array();
$keys = array_keys( $categories );

foreach( $keys as $k ) {
	if ( in_array( $categories[$k]->term_id, $args['selected_cats'] ) ) {
		$checked_categories[] = $categories[$k];
		unset( $categories[$k] );
	}
}

// Save data
if(isset($_POST) && !empty($_POST))
{
	if(isset($_FILES) && !empty($_FILES) && $_FILES['async-upload']['name'] != '')
	{
		$id = media_handle_upload('async-upload', $_REQUEST['post_id']);
		$file = get_attachment_icon_src($id, true);
		if($_POST['file_upload_location'] == 'top')
		{
			$_POST['content'] = '<img src="'.$file[0].'" />
'.$_POST['content'];
		} else if($_POST['file_upload_location'] == 'bottom')
		{
			$_POST['content'] .= '
<img src="'.$file[0].'" />';
		}
	}
	
	// Set post category
	$_POST['post_category'] = array();
	foreach(array_merge($checked_categories, $categories) as $cat)
	{
		if(isset($_POST['post_category_'.$cat->cat_ID]) AND $_POST['post_category_'.$cat->cat_ID] == true)
		{
			$_POST['post_category'][] = $cat->cat_ID;
		}
	}
	
	if(edit_post($_POST))
	{
		header("Location:".admin_url().$_POST['_wp_http_referer'].'?message=1');
		exit();
	}
}

$waplString = '';
$pageTitle = 'Edit Post';
$pageId = 'editPost';

// Header
$waplString .= require_once(ARCHITECT_ADMIN_DIR.'wp-admin'.DIRECTORY_SEPARATOR.'header.php');

// Navigation
$waplString .= require_once(ARCHITECT_ADMIN_DIR.'wp-admin'.DIRECTORY_SEPARATOR.'menu'.DIRECTORY_SEPARATOR.'main.php');
$waplString .= require_once(ARCHITECT_ADMIN_DIR.'wp-admin'.DIRECTORY_SEPARATOR.'menu'.DIRECTORY_SEPARATOR.'edit.php');
$waplString .= '<wordsChunk id="'.$pageId.'"><quick_text>[p]edit post[/p][h2]'.$pageH1.'[/h2]</quick_text></wordsChunk>';

// Set up some variables we need for the form
global $user_ID;

$waplString .= '
<form>
	<action>post.php</action>
	<formItem item_type="hidden"><name>post_author</name><value>'.$post->post_author.'</value></formItem>
	<formItem item_type="hidden"><name>user_ID</name><value>'.(int) $user_ID.'</value></formItem>
	<formItem item_type="hidden"><name>post_ID</name><value>'.$post->ID.'</value></formItem>
	<formItem item_type="hidden"><name>post</name><value>'.$post->ID.'</value></formItem>
	<formItem item_type="hidden"><name>ID</name><value>'.$post->ID.'</value></formItem>
	<formItem item_type="hidden"><name>post_type</name><value>post</value></formItem>
	<formItem item_type="hidden"><name>comment_status</name><value>'.$post->comment_status.'</value></formItem>
	<formItem item_type="hidden"><name>ping_status</name><value>'.$post->ping_status.'</value></formItem>
	<formItem item_type="hidden"><name>action</name><value>save</value></formItem>
	<formItem item_type="hidden"><name>_wp_http_referer</name><value>edit.php</value></formItem>
	<formItem item_type="text"><label>Title</label><name>post_title</name><value>'.$post->post_title.'</value></formItem>';

$trans = '';
$trans = (is_array($trans)) ? $trans : get_html_translation_table(HTML_ENTITIES, ENT_QUOTES);
foreach ($trans as $k=>$v)
	$trans[$k]= "&#".ord($k).";";

$waplString .= '
	<formItem item_type="textarea"><label>Content</label><name>content</name><value>'.htmlentities(strtr($post->post_content, $trans)).'</value></formItem>';

$waplString .= '
	<formItem item_type="textarea"><label>Excerpt</label><name>excerpt</name><value>'.$post->post_excerpt.'</value></formItem>';
$current_user = wp_get_current_user();
$user_id = $current_user->ID;
$can_upload = get_option('architect_admin_file_upload_'.$user_id);

if($can_upload === '0')
{
	$waplString .= '<formItem item_type="title"><name>async-upload-off</name><label>File uploading is disabled for this user. To re-enable it, switch it back on in the [url=profile.php]Profile[/url] page</label></formItem>';
} else
{
	$waplString .= '<formItem item_type="file"><label>File Upload</label><name>async-upload</name></formItem>';
	$waplString .= '<formItem item_type="select">
		<label>Image Location</label><name>file_upload_location</name>
		<possibility>
			<label>Top</label>
			<value>top</value>
		</possibility>
		<possibility>
			<label>Bottom</label>
			<value>bottom</value>
		</possibility>
	</formItem>';
}

$waplString .= '
	<formItem item_type="select"><name>post_status</name>
	<value>'.$post->post_status.'</value>
	<label>Post Status</label>
		<possibility>
			<label>Draft</label>
			<value>draft</value>
		</possibility>
		<possibility>
			<label>Pending Review</label>
			<value>pending</value>
		</possibility>
		<possibility>
			<label>Published</label>
			<value>publish</value>
		</possibility>
	</formItem>';

// Category stuff here
$waplString .= '<formItem class="dashboardSection" item_type="title"><label>Categories</label><name>categories</name></formItem>';

foreach($checked_categories as $val)
{
	$waplString .= '<formItem class="postCheckbox" item_type="checkbox"><label>'.$val->name.'</label><name>post_category_'.$val->cat_ID.'</name><value>1</value></formItem>';
}
foreach($categories as $val)
{
	$waplString .= '<formItem class="postCheckbox" item_type="checkbox"><label>'.$val->name.'</label><name>post_category_'.$val->cat_ID.'</name><value>0</value></formItem>';
}
$waplString .= '<formItem item_type="submit"><label>Save</label><name>edit_post_save</name></formItem></form>';

// Footer
$waplString .= require_once(ARCHITECT_ADMIN_DIR.'wp-admin'.DIRECTORY_SEPARATOR.'footer.php');

// Convert WAPL into markup
process_admin_wapl($waplString);
?>